diff -crB mplp_ver2/cycle.h mplp_ver2.src-patched/cycle.h
*** mplp_ver2/cycle.h	2014-10-19 21:32:10.000000000 +0200
--- mplp_ver2.src-patched/cycle.h	2014-02-25 10:05:55.000000000 +0100
***************
*** 1391,1418 ****
      exist_duplicates = false;
      
      // This map allows us to quickly find duplicates and their locations within the cycle
!     map<int, int> duplicates_map;
  					
      // Must keep track of sign.
      cycle_sign[cycle_start] = 1;
      
!     duplicates_map.insert(pair<int,int>(projection_imap_var[cycle_array[cycle_start]], cycle_start));
      for(int i=cycle_start+1; i <= cycle_end; i++) {
        
        // Get edge weight
!       map< pair<int,int>, double>::iterator weights_iter = projection_edge_weights.find(make_pair(cycle_array[i-1], cycle_array[i]));
        
        double smn = weights_iter->second;
        int sign_of_smn = (smn > 0) - (smn < 0);
        cycle_sign[i] = cycle_sign[i-1]*sign_of_smn;
  			
        // Does node i already exist in the map?
!       map<int, int>::iterator dups_iter = duplicates_map.find(projection_imap_var[cycle_array[i]]);
        if( dups_iter != duplicates_map.end() ) { // Duplicate found
          int first_occurence_index = dups_iter->second;
          
          // Look to see if the first half of the cycle is violated.
!         weights_iter = projection_edge_weights.find(make_pair(cycle_array[first_occurence_index], cycle_array[i-1]));        
          double edge_weight = weights_iter->second;
          int sign_of_edge = (edge_weight > 0) - (edge_weight < 0);
          
--- 1390,1417 ----
      exist_duplicates = false;
      
      // This map allows us to quickly find duplicates and their locations within the cycle
!     std::map<int, int> duplicates_map;
  					
      // Must keep track of sign.
      cycle_sign[cycle_start] = 1;
      
!     duplicates_map.insert(std::pair<int,int>(projection_imap_var[cycle_array[cycle_start]], cycle_start));
      for(int i=cycle_start+1; i <= cycle_end; i++) {
        
        // Get edge weight
!        std::map< std::pair<int,int>, double>::iterator weights_iter = projection_edge_weights.find(std::make_pair(cycle_array[i-1], cycle_array[i]));
        
        double smn = weights_iter->second;
        int sign_of_smn = (smn > 0) - (smn < 0);
        cycle_sign[i] = cycle_sign[i-1]*sign_of_smn;
  			
        // Does node i already exist in the map?
!       std::map<int, int>::iterator dups_iter = duplicates_map.find(projection_imap_var[cycle_array[i]]);
        if( dups_iter != duplicates_map.end() ) { // Duplicate found
          int first_occurence_index = dups_iter->second;
          
          // Look to see if the first half of the cycle is violated.
!         weights_iter = projection_edge_weights.find(std::make_pair(cycle_array[first_occurence_index], cycle_array[i-1]));
          double edge_weight = weights_iter->second;
          int sign_of_edge = (edge_weight > 0) - (edge_weight < 0);
          
***************
*** 1437,1443 ****
        }
        else {
          // Insert into the map
!         duplicates_map.insert(pair<int,int>(projection_imap_var[cycle_array[i]], i));
        }
      }
    }
--- 1436,1442 ----
        }
        else {
          // Insert into the map
!         duplicates_map.insert(std::pair<int,int>(projection_imap_var[cycle_array[i]], i));
        }
      }
    }
***************
*** 1449,1455 ****
  }
  
  
! int add_cycle(MPLPAlg& mplp, list<int> &cycle, vector<int> &projection_imap_var, map<vector<int>, bool >& triplet_set, int& num_projection_nodes) {
  
    int nClustersAdded = 0;
  
--- 1448,1454 ----
  }
  
  
! int add_cycle(MPLPAlg& mplp, std::list<int> &cycle, std::vector<int> &projection_imap_var, std::map<std::vector<int>, bool >& triplet_set, int& num_projection_nodes) {
  
    int nClustersAdded = 0;
  
***************
*** 1460,1467 ****
  
    // Convert cycle to array
    int cycle_array[cycle.size()]; int tmp_ind = 0;
!   for (list<int>::iterator it=cycle.begin(); it!=cycle.end(); ++it) { // this is unnecesary
!     //    if (DEBUG_MODE) {
      //      if (*it >= num_projection_nodes) {
      //        cout << "Cycle uses non-trivial partitionining." << endl;
      //      }
--- 1459,1466 ----
  
    // Convert cycle to array
    int cycle_array[cycle.size()]; int tmp_ind = 0;
!   for (std::list<int>::iterator it=cycle.begin(); it!=cycle.end(); ++it) { // this is unnecesary
!     //    if (MPLP_DEBUG_MODE) {
      //      if (*it >= num_projection_nodes) {
      //        cout << "Cycle uses non-trivial partitionining." << endl;
      //      }
***************
*** 1470,1476 ****
    }
  		
    // Found violated cycle, now triangulate and add to the relaxation!
!   for(int i=0; i+1 < cycle.size()-2-i; i++) {
  					
      // Add projection_imap_var applied to [i, i+1, cycle.size()-2-i]
      newCluster[cluster_index].i = projection_imap_var[cycle_array[i]];
--- 1469,1475 ----
    }
  		
    // Found violated cycle, now triangulate and add to the relaxation!
!   for(size_t i=0; i+1 < cycle.size()-2-i; i++) {
  					
      // Add projection_imap_var applied to [i, i+1, cycle.size()-2-i]
      newCluster[cluster_index].i = projection_imap_var[cycle_array[i]];
***************
*** 1480,1486 ****
      cluster_index++;
    }
  
!   for(int i=cycle.size()-1; i-1 > cycle.size()-1-i; i--) {
        
      // Add projection_imap_var applied to [i, i-1, cycle.size()-1-i]
      newCluster[cluster_index].i = projection_imap_var[cycle_array[i]];
--- 1479,1485 ----
      cluster_index++;
    }
  
!   for(size_t i=cycle.size()-1; i-1 > cycle.size()-1-i; i--) {
        
      // Add projection_imap_var applied to [i, i-1, cycle.size()-1-i]
      newCluster[cluster_index].i = projection_imap_var[cycle_array[i]];
***************
*** 1493,1499 ****
    // Add the top nclus_to_add clusters to the relaxation
    for(int clusterId = 0; clusterId < nNewClusters; clusterId++) {
      // Check that these clusters and intersection sets haven't already been added
!     vector<int> temp;
      temp.push_back(newCluster[clusterId].i);
      temp.push_back(newCluster[clusterId].j);
      temp.push_back(newCluster[clusterId].k);
--- 1492,1498 ----
    // Add the top nclus_to_add clusters to the relaxation
    for(int clusterId = 0; clusterId < nNewClusters; clusterId++) {
      // Check that these clusters and intersection sets haven't already been added
!     std::vector<int> temp;
      temp.push_back(newCluster[clusterId].i);
      temp.push_back(newCluster[clusterId].j);
      temp.push_back(newCluster[clusterId].k);
***************
*** 1502,1537 ****
      // Check to see if this cluster involves two of the same variables
      // (could happen because we didn't shortcut)
      if(temp[0] == temp[1] || temp[0] == temp[2] || temp[1] == temp[2]) {
!       //      if(DEBUG_MODE)
        //	cout << "skipping this triplet because it is an edge." << endl;
        continue;
      }
      
!     map<vector<int>, bool >::iterator t_itr = triplet_set.find(temp);
      if (t_itr == triplet_set.end())
!       triplet_set.insert(pair<vector<int>, bool >(temp, true));
      else {
!       //	if(DEBUG_MODE)
        //	  cout << "   Triplet was already present. Skipping..." << endl;
        continue; 
      }
  				
      // Find the intersection sets for this triangle
!     vector<int> ij_edge; ij_edge.push_back(newCluster[clusterId].i); ij_edge.push_back(newCluster[clusterId].j);
      newCluster[clusterId].ij_intersect_loc = mplp.FindIntersectionSet(ij_edge);
      // This edge intersection set may not already exist, in which case we should add it
      if(newCluster[clusterId].ij_intersect_loc == -1) {
        newCluster[clusterId].ij_intersect_loc = mplp.AddIntersectionSet(ij_edge);
      }
      
!     vector<int> jk_edge; jk_edge.push_back(newCluster[clusterId].j); jk_edge.push_back(newCluster[clusterId].k);
      newCluster[clusterId].jk_intersect_loc = mplp.FindIntersectionSet(jk_edge);
      // This edge intersection set may not already exist, in which case we should add it
      if(newCluster[clusterId].jk_intersect_loc == -1) {
        newCluster[clusterId].jk_intersect_loc = mplp.AddIntersectionSet(jk_edge);
      }
      
!     vector<int> ki_edge; ki_edge.push_back(newCluster[clusterId].k); ki_edge.push_back(newCluster[clusterId].i);
      newCluster[clusterId].ki_intersect_loc = mplp.FindIntersectionSet(ki_edge);
      // This edge intersection set may not already exist, in which case we should add it
      if(newCluster[clusterId].ki_intersect_loc == -1) {
--- 1501,1536 ----
      // Check to see if this cluster involves two of the same variables
      // (could happen because we didn't shortcut)
      if(temp[0] == temp[1] || temp[0] == temp[2] || temp[1] == temp[2]) {
!       //      if(MPLP_DEBUG_MODE)
        //	cout << "skipping this triplet because it is an edge." << endl;
        continue;
      }
      
!     std::map<std::vector<int>, bool >::iterator t_itr = triplet_set.find(temp);
      if (t_itr == triplet_set.end())
!       triplet_set.insert(std::pair<std::vector<int>, bool >(temp, true));
      else {
!       //	if(MPLP_DEBUG_MODE)
        //	  cout << "   Triplet was already present. Skipping..." << endl;
        continue; 
      }
  				
      // Find the intersection sets for this triangle
!     std::vector<int> ij_edge; ij_edge.push_back(newCluster[clusterId].i); ij_edge.push_back(newCluster[clusterId].j);
      newCluster[clusterId].ij_intersect_loc = mplp.FindIntersectionSet(ij_edge);
      // This edge intersection set may not already exist, in which case we should add it
      if(newCluster[clusterId].ij_intersect_loc == -1) {
        newCluster[clusterId].ij_intersect_loc = mplp.AddIntersectionSet(ij_edge);
      }
      
!     std::vector<int> jk_edge; jk_edge.push_back(newCluster[clusterId].j); jk_edge.push_back(newCluster[clusterId].k);
      newCluster[clusterId].jk_intersect_loc = mplp.FindIntersectionSet(jk_edge);
      // This edge intersection set may not already exist, in which case we should add it
      if(newCluster[clusterId].jk_intersect_loc == -1) {
        newCluster[clusterId].jk_intersect_loc = mplp.AddIntersectionSet(jk_edge);
      }
      
!     std::vector<int> ki_edge; ki_edge.push_back(newCluster[clusterId].k); ki_edge.push_back(newCluster[clusterId].i);
      newCluster[clusterId].ki_intersect_loc = mplp.FindIntersectionSet(ki_edge);
      // This edge intersection set may not already exist, in which case we should add it
      if(newCluster[clusterId].ki_intersect_loc == -1) {
***************
*** 1539,1548 ****
      }			
      
      // Now add cluster ijk
!     vector<int> ijk_inds;
      ijk_inds.push_back(newCluster[clusterId].i); ijk_inds.push_back(newCluster[clusterId].j); ijk_inds.push_back(newCluster[clusterId].k);
      
!     vector<int> ijk_intersect_inds;
      ijk_intersect_inds.push_back(newCluster[clusterId].ij_intersect_loc);
      ijk_intersect_inds.push_back(newCluster[clusterId].jk_intersect_loc);
      ijk_intersect_inds.push_back(newCluster[clusterId].ki_intersect_loc);
--- 1538,1547 ----
      }			
      
      // Now add cluster ijk
!     std::vector<int> ijk_inds;
      ijk_inds.push_back(newCluster[clusterId].i); ijk_inds.push_back(newCluster[clusterId].j); ijk_inds.push_back(newCluster[clusterId].k);
      
!     std::vector<int> ijk_intersect_inds;
      ijk_intersect_inds.push_back(newCluster[clusterId].ij_intersect_loc);
      ijk_intersect_inds.push_back(newCluster[clusterId].jk_intersect_loc);
      ijk_intersect_inds.push_back(newCluster[clusterId].ki_intersect_loc);
***************
*** 1564,1583 ****
   * method=1: use create_k_projection_graph
   * method=2: use create_expanded_projection_graph
   */
! int TightenCycle(MPLPAlg & mplp, int nclus_to_add,  map<vector<int>, bool >& triplet_set, double & promised_bound, int method) {
  		
    int nClustersAdded = 0;
!   int nNewClusters;
  
!   if (DEBUG_MODE) cout << "Finding the most violated cycle...." << endl;
  
    // This map allows us to quickly look up the edge weights
!   map<pair<int, int>, double> projection_edge_weights;
    int num_projection_nodes;
!   vector<vector<int> > projection_map;
!   vector<int> projection_imap_var;  
!   vector<vector<pair<int, double> > > projection_adjacency_list;
!   vector<vector<int> > partition_imap;
    
    double* array_of_sij; int array_of_sij_size;
  
--- 1563,1582 ----
   * method=1: use create_k_projection_graph
   * method=2: use create_expanded_projection_graph
   */
! int TightenCycle(MPLPAlg & mplp, int nclus_to_add,  std::map<std::vector<int>, bool >& triplet_set, double & promised_bound, int method) {
  		
    int nClustersAdded = 0;
!   //int nNewClusters;
  
!   if (MPLP_DEBUG_MODE) std::cout << "Finding the most violated cycle...." << std::endl;
  
    // This map allows us to quickly look up the edge weights
!   std::map<std::pair<int, int>, double> projection_edge_weights;
    int num_projection_nodes;
!   std::vector<std::vector<int> > projection_map;
!   std::vector<int> projection_imap_var;
!   std::vector<std::vector<std::pair<int, double> > > projection_adjacency_list;
!   std::vector<std::vector<int> > partition_imap;
    
    double* array_of_sij; int array_of_sij_size;
  
***************
*** 1587,1599 ****
    else if(method == 1)
      create_k_projection_graph(mplp, projection_map, num_projection_nodes, projection_imap_var, partition_imap, projection_edge_weights, projection_adjacency_list, array_of_sij, array_of_sij_size);
    else {
!     cout << "ERROR: method not defined." << endl;
      return 0;
    }
  
!   vector<list<int> > cycle_set;
    double optimal_R = find_optimal_R(projection_adjacency_list, array_of_sij, array_of_sij_size);
!   if (DEBUG_MODE) cout << "R_optimal = " << optimal_R << endl;
  
    promised_bound = optimal_R;
    
--- 1586,1598 ----
    else if(method == 1)
      create_k_projection_graph(mplp, projection_map, num_projection_nodes, projection_imap_var, partition_imap, projection_edge_weights, projection_adjacency_list, array_of_sij, array_of_sij_size);
    else {
!      std::cout << "ERROR: method not defined." << std::endl;
      return 0;
    }
  
!   std::vector<std::list<int> > cycle_set;
    double optimal_R = find_optimal_R(projection_adjacency_list, array_of_sij, array_of_sij_size);
!   if (MPLP_DEBUG_MODE) std::cout << "R_optimal = " << optimal_R << std::endl;
  
    promised_bound = optimal_R;
    
***************
*** 1615,1642 ****
  
    clock_t end_time = clock();
    double total_time = (double)(end_time - start_time)/CLOCKS_PER_SEC;
!   if (DEBUG_MODE) {
      printf(" -- FindCycles. Took %lg seconds\n", total_time);
    } 
  
    
    // Add all cycles that we've found to the relaxation!
    start_time = clock();
!   for (int z = 0; z < cycle_set.size() && nClustersAdded < nclus_to_add; z++) {
      
      // Check to see if there are any duplicate nodes, and, if so, shortcut
      //    shortcut(cycle_set[z], projection_imap_var, projection_edge_weights, num_projection_nodes);
  
      // Output the cycle
!     if (DEBUG_MODE){
!       for (list<int>::iterator it=cycle_set[z].begin(); it!=cycle_set[z].end(); ++it) {
! 	cout << projection_imap_var[*it] << "(";
! 	vector<int> temp = partition_imap[*it];          
! 	for(int s=0; s < temp.size()-1; s++)
! 	  cout << temp[s] << ",";
! 	cout << temp[temp.size()-1] << "), ";          
        }
!       cout << endl;
      } 
  
      // Add cycle to the relaxation
--- 1614,1641 ----
  
    clock_t end_time = clock();
    double total_time = (double)(end_time - start_time)/CLOCKS_PER_SEC;
!   if (MPLP_DEBUG_MODE) {
      printf(" -- FindCycles. Took %lg seconds\n", total_time);
    } 
  
    
    // Add all cycles that we've found to the relaxation!
    start_time = clock();
!   for (size_t z = 0; z < cycle_set.size() && nClustersAdded < nclus_to_add; z++) {
      
      // Check to see if there are any duplicate nodes, and, if so, shortcut
      //    shortcut(cycle_set[z], projection_imap_var, projection_edge_weights, num_projection_nodes);
  
      // Output the cycle
!     if (MPLP_DEBUG_MODE){
!       for (std::list<int>::iterator it=cycle_set[z].begin(); it!=cycle_set[z].end(); ++it) {
!          std::cout << projection_imap_var[*it] << "(";
!          std::vector<int> temp = partition_imap[*it];
!          for(size_t s=0; s < temp.size()-1; s++)
!             std::cout << temp[s] << ",";
!          std::cout << temp[temp.size()-1] << "), ";
        }
!       std::cout << std::endl;
      } 
  
      // Add cycle to the relaxation
***************
*** 1645,1651 ****
  
    end_time = clock();
    total_time = (double)(end_time - start_time)/CLOCKS_PER_SEC;
!   if (DEBUG_MODE) {
      printf(" -- shortcut + add_cycles. Took %lg seconds\n", total_time);
    } 
    
--- 1644,1650 ----
  
    end_time = clock();
    total_time = (double)(end_time - start_time)/CLOCKS_PER_SEC;
!   if (MPLP_DEBUG_MODE) {
      printf(" -- shortcut + add_cycles. Took %lg seconds\n", total_time);
    } 
    
Only in mplp_ver2: ._cycle_tighten_main.cpp
diff -crB mplp_ver2/cycle_tighten_main.cpp mplp_ver2.src-patched/cycle_tighten_main.cpp
*** mplp_ver2/cycle_tighten_main.cpp	2014-10-19 21:33:12.000000000 +0200
--- mplp_ver2.src-patched/cycle_tighten_main.cpp	2014-11-19 10:02:28.101324291 +0100
***************
*** 13,33 ****
   *  We did not use this for the UAI 2012 paper (i.e., we did not set INF_TIME).
   */
  #include <iostream>
- 
- using namespace std;
- 
  #include <ctime>
  #include <math.h>
- #include "cycle.h" // Most of the logic is in here.
- 
- #include <iostream>
  #include <fstream>
  #include <vector>
  
  #define MAX_TIGHT_ITERS 1000000 // 100 used for testing
  
  int main( int argc, char *argv[] ){
!   // Note: DEBUG_MODE flag can be found in "cycle.h"
    // DEFAULT values:
    int niter = 1000, niter_later = 20, nclus_to_add_min = 5, nclus_to_add_max = 20;
    double obj_del_thr = .0002, int_gap_thr = .0002;
--- 13,31 ----
   *  We did not use this for the UAI 2012 paper (i.e., we did not set INF_TIME).
   */
  #include <iostream>
  #include <ctime>
  #include <math.h>
  #include <fstream>
  #include <vector>
  
+ #include "cycle.h" // Most of the logic is in here.
+ 
+ using namespace std;
+ 
  #define MAX_TIGHT_ITERS 1000000 // 100 used for testing
  
  int main( int argc, char *argv[] ){
!   // Note: MPLP_DEBUG_MODE flag can be found in "cycle.h"
    // DEFAULT values:
    int niter = 1000, niter_later = 20, nclus_to_add_min = 5, nclus_to_add_max = 20;
    double obj_del_thr = .0002, int_gap_thr = .0002;
***************
*** 63,69 ****
      time_limit = (double)atoi(t);
    }
  
!   if(DEBUG_MODE)
      cout << "Time limit = " << time_limit << endl;
  
    bool decimation_has_started = false;
--- 61,67 ----
      time_limit = (double)atoi(t);
    }
  
!   if(MPLP_DEBUG_MODE)
      cout << "Time limit = " << time_limit << endl;
  
    bool decimation_has_started = false;
***************
*** 92,98 ****
      sscanf(argv[3],"%d",&seed);
    else seed = 0; // default if not provided as input
  
!   if(DEBUG_MODE) cout << "Random seed = " << seed << endl;
    srand(seed);
  
    // currently not used (since we only perform MPE)
--- 90,96 ----
      sscanf(argv[3],"%d",&seed);
    else seed = 0; // default if not provided as input
  
!   if(MPLP_DEBUG_MODE) cout << "Random seed = " << seed << endl;
    srand(seed);
  
    // currently not used (since we only perform MPE)
***************
*** 109,130 ****
    if(LOG_MODE) {
      fprintf(log_file, "I niter=%d, niter_later=%d, nclus_to_add_min=%d, nclus_to_add_max=%d, obj_del_thr=%lg, int_gap_thr=%lg\n", niter, niter_later, nclus_to_add_min, nclus_to_add_max, obj_del_thr,int_gap_thr);
    }
!   if (DEBUG_MODE) printf("niter=%d\nniter_later=%d\nnclus_to_add=%d\nobj_del_thr=%lg\nint_gap_thr=%lg\n",niter, niter_later, nclus_to_add_min,obj_del_thr,int_gap_thr);
  
    // Load in the MRF and initialize GMPLP state
    MPLPAlg mplp(start, time_limit, input_file, evidence_file, log_file, lookForCSPs);
  
!   if (DEBUG_MODE) printf("Initially running MPLP for %d iterations\n", niter);
    mplp.RunMPLP(niter, obj_del_thr, int_gap_thr);
  
    for(int iter=1; iter<MAX_TIGHT_ITERS; iter++){  // Break when problem is solved
      if(LOG_MODE) fflush(log_file);
!     if (DEBUG_MODE) printf("\n\nOuter loop iteration %d\n----------------------\n", iter);
  
      // Is problem solved? If so, break.
      double int_gap = mplp.last_obj - mplp.m_best_val;
      if(int_gap < int_gap_thr){
!       if (DEBUG_MODE) printf("Done! Integrality gap less than %lg\n", int_gap_thr);
        break;
      }
  
--- 107,128 ----
    if(LOG_MODE) {
      fprintf(log_file, "I niter=%d, niter_later=%d, nclus_to_add_min=%d, nclus_to_add_max=%d, obj_del_thr=%lg, int_gap_thr=%lg\n", niter, niter_later, nclus_to_add_min, nclus_to_add_max, obj_del_thr,int_gap_thr);
    }
!   if (MPLP_DEBUG_MODE) printf("niter=%d\nniter_later=%d\nnclus_to_add=%d\nobj_del_thr=%lg\nint_gap_thr=%lg\n",niter, niter_later, nclus_to_add_min,obj_del_thr,int_gap_thr);
  
    // Load in the MRF and initialize GMPLP state
    MPLPAlg mplp(start, time_limit, input_file, evidence_file, log_file, lookForCSPs);
  
!   if (MPLP_DEBUG_MODE) printf("Initially running MPLP for %d iterations\n", niter);
    mplp.RunMPLP(niter, obj_del_thr, int_gap_thr);
  
    for(int iter=1; iter<MAX_TIGHT_ITERS; iter++){  // Break when problem is solved
      if(LOG_MODE) fflush(log_file);
!     if (MPLP_DEBUG_MODE) printf("\n\nOuter loop iteration %d\n----------------------\n", iter);
  
      // Is problem solved? If so, break.
      double int_gap = mplp.last_obj - mplp.m_best_val;
      if(int_gap < int_gap_thr){
!       if (MPLP_DEBUG_MODE) printf("Done! Integrality gap less than %lg\n", int_gap_thr);
        break;
      }
  
***************
*** 134,140 ****
      if(int_gap < 1){
        niter_later = max(niter_later, 600);  // TODO opt: don't hard code
        obj_del_thr = min(obj_del_thr, 1e-5);
!       if (DEBUG_MODE) printf("Int gap small, so setting niter_later to %d and obj_del_thr to %lg\n", niter_later, obj_del_thr);
      }
  
      // Keep track of global decoding time and run this frequently, but at most 20% of total runtime
--- 132,138 ----
      if(int_gap < 1){
        niter_later = max(niter_later, 600);  // TODO opt: don't hard code
        obj_del_thr = min(obj_del_thr, 1e-5);
!       if (MPLP_DEBUG_MODE) printf("Int gap small, so setting niter_later to %d and obj_del_thr to %lg\n", niter_later, obj_del_thr);
      }
  
      // Keep track of global decoding time and run this frequently, but at most 20% of total runtime
***************
*** 151,157 ****
      }
      
      // Tighten LP
!     if (DEBUG_MODE) cout << "Now attempting to tighten LP relaxation..." << endl;
  
      clock_t tightening_start_time = clock();
      double bound=0; double bound2 = 0;
--- 149,155 ----
      }
      
      // Tighten LP
!     if (MPLP_DEBUG_MODE) cout << "Now attempting to tighten LP relaxation..." << endl;
  
      clock_t tightening_start_time = clock();
      double bound=0; double bound2 = 0;
***************
*** 162,168 ****
  
      if(max(bound, bound2) < CLUSTER_THR) {
  
!       if(DEBUG_MODE)
  	cout << "TightenCycle did not find anything useful! Re-running with FindPartition." << endl;
  
        nClustersAdded += TightenCycle(mplp, nclus_to_add_min, triplet_set, bound2, 2);
--- 160,166 ----
  
      if(max(bound, bound2) < CLUSTER_THR) {
  
!       if(MPLP_DEBUG_MODE)
  	cout << "TightenCycle did not find anything useful! Re-running with FindPartition." << endl;
  
        nClustersAdded += TightenCycle(mplp, nclus_to_add_min, triplet_set, bound2, 2);
***************
*** 176,182 ****
  
      clock_t tightening_end_time = clock();
      double tightening_total_time = (double)(tightening_end_time - tightening_start_time)/CLOCKS_PER_SEC;
!     if (DEBUG_MODE) {
        printf(" -- Added %d clusters to relaxation. Took %lg seconds\n", nClustersAdded, tightening_total_time);
      }
      if(LOG_MODE) {
--- 174,180 ----
  
      clock_t tightening_end_time = clock();
      double tightening_total_time = (double)(tightening_end_time - tightening_start_time)/CLOCKS_PER_SEC;
!     if (MPLP_DEBUG_MODE) {
        printf(" -- Added %d clusters to relaxation. Took %lg seconds\n", nClustersAdded, tightening_total_time);
      }
      if(LOG_MODE) {
***************
*** 210,223 ****
  
  	bool fixed_node = mplp.RunDecimation();
  	if(!fixed_node) {
! 	  if(DEBUG_MODE)
  	    cout << "Decimation fixed all of the nodes it could... quiting." << endl;
  	  break;
  	}
        }
      }
  
!     if (DEBUG_MODE) printf("Running MPLP again for %d more iterations\n", niter_later);
      mplp.RunMPLP(niter_later, obj_del_thr, int_gap_thr);
  
      if(UAIsettings) {
--- 208,221 ----
  
  	bool fixed_node = mplp.RunDecimation();
  	if(!fixed_node) {
! 	  if(MPLP_DEBUG_MODE)
  	    cout << "Decimation fixed all of the nodes it could... quiting." << endl;
  	  break;
  	}
        }
      }
  
!     if (MPLP_DEBUG_MODE) printf("Running MPLP again for %d more iterations\n", niter_later);
      mplp.RunMPLP(niter_later, obj_del_thr, int_gap_thr);
  
      if(UAIsettings) {
Only in mplp_ver2: ._gpl.txt
Only in mplp_ver2: ._grid4x4.uai
Only in mplp_ver2: ._grid4x4.uai.evid
Only in mplp_ver2: ._Makefile
Only in mplp_ver2: ._matrix.cpp
diff -crB mplp_ver2/matrix.cpp mplp_ver2.src-patched/matrix.cpp
*** mplp_ver2/matrix.cpp	2012-08-08 20:25:06.000000000 +0200
--- mplp_ver2.src-patched/matrix.cpp	2014-02-25 10:05:55.000000000 +0100
***************
*** 1,3 ****
--- 1,6 ----
+ #include <cstdlib> // for rand
+ #include <cstring> // for memcpy
+ 
  #include "matrix.h"
  
  using namespace std;
Only in mplp_ver2: ._matrix.h
diff -crB mplp_ver2/matrix.h mplp_ver2.src-patched/matrix.h
*** mplp_ver2/matrix.h	2012-08-08 20:25:06.000000000 +0200
--- mplp_ver2.src-patched/matrix.h	2014-02-25 10:05:55.000000000 +0100
***************
*** 1,3 ****
--- 1,6 ----
+ #ifndef MPLP_MATRIX_H
+ #define MPLP_MATRIX_H
+ 
  #include <iostream>
  #include <fstream>
  
***************
*** 137,139 ****
--- 140,144 ----
  void VecMaxEnt( Matrix & f_val, Matrix & f_exp, Vec & p0, int ep, Matrix & lambdas, Vec & zs, bool brows, double maxentthr);
  double dot(double *a, double *b, int n);
  void ConjGradMaxEntVec( Matrix & f_val, Matrix & ref_p, Matrix & p_proj, int ep, Matrix & lambdas, Vec & zs, bool brow);
+ 
+ #endif
Only in mplp_ver2: ._mplp_alg.cpp
